'use strict';

/* globals document, $, bootbox, window, app, ajaxify, config */

$(document).ready(function () {
	var strings = {
		0: 'is no longer buried',
		1: 'has been buried to everyone except those who have been to the topic before.',
		2: 'has been buried to everyone except those who have replied to the topic',
	};
	var process = function (type) {
		$.ajax({
			type: type ? 'post' : 'delete',
			url: config.relative_path + '/api/topics/' + ajaxify.data.tid + '/bury',
			data: {
				bury: type,
			},
		}).done(function () {
			app.alertSuccess('This topic ' + strings[type]);
			ajaxify.data.buried = parseInt(type, 10);
		});
	};

	$(window).on('action:topic.tools.load', function (event, data) {
		data.element.on('click', '.bury-topic', function () {
			app.parseAndTranslate('partials/topic/bury', {
				state: {
					0: parseInt(ajaxify.data.buried, 10) === 0,
					1: parseInt(ajaxify.data.buried, 10) === 1,
					2: parseInt(ajaxify.data.buried, 10) === 2,
				},
				buried: parseInt(ajaxify.data.buried, 10) === 1 || parseInt(ajaxify.data.buried, 10) === 2,
			}, function (html) {
				bootbox.dialog({
					title: 'Bury/Restore Topic',
					message: html,
					onEscape: true,
					backdrop: true,
					buttons: {
						0: {
							label: 'Restore Topic',
							className: 'btn-link',
							callback: process.bind(this, 0),
						},
						1: {
							label: 'Viewers',
							className: 'btn-warning',
							callback: process.bind(this, 1),
						},
						2: {
							label: 'Repliers',
							className: 'btn-danger',
							callback: process.bind(this, 2),
						},
					},
				});
			});
		});
	});
});
